lines <- readLines("data.txt")
starts <- which(lines == "new dataset")

medians <- array(NA, c(21, 2, length(starts)))
rownames(medians) <- c(paste0("Q", 1:20), "Inactive")
colnames(medians) <- c("F", "M")

tabs <- array(NA, c(21, 21, length(starts)))
rownames(tabs) <- colnames(tabs) <- c(paste0("Q", 1:20), "Inactive")

codes <- character(length(starts))

for(i in 1:length(starts)) {
    si <- starts[i]
    offset <- 3
    code <- lines[si+offset]

    datf <- read.table(textConnection(lines[si + offset +  4 + 1:21]), strip.white=TRUE, na.strings=".")
    datm <- read.table(textConnection(lines[si + offset + 31 + 1:21]), strip.white=TRUE, na.strings=".")
    medians[, "F", i] <- datf[[3]]
    medians[, "M", i] <- datm[[3]]

    dat <- read.table(textConnection(lines[si + offset + 59 + 1:21]), strip.white=TRUE, na.strings=".")
    tab <- as.matrix(dat[-c(1, 2)])
    tab[is.na(tab)] <- 0
    tabs[,, i] <- tab
    codes[i] <- code
}

dimnames(tabs)[[3]] <- dimnames(medians)[[3]] <- codes

# Improper datasets (red)
codes <- setdiff(codes, c("au89", "es95", "fr94", "hu94", "hu09", "lu85", "lu97", "nl93", "no79", "no13", "pl95"))
# Datasets where zero earners have to be excluded and which are still not OK (orange)
codes <- setdiff(codes, c("ca81", "uk95"))
# Remove Belgium (too short period), Poland (too few correct datasets) and Mexico
codes <- codes[!substr(codes, 1, 2) %in% c("be", "pl", "mx")]

tabs <- tabs[,,codes]
medians <- medians[,,codes]

countries <- sort(unique(substr(dimnames(tabs)[[3]], 1, 2)))
countries <- countries[countries != "" & countries != "sk"]

countrynames <- ISOcodes::ISO_3166_1$Name
names(countrynames) <- ISOcodes::ISO_3166_1$Alpha_2
names(countrynames)[names(countrynames) == "GB"] <- "UK"

countries <- countries[order(countrynames[toupper(countries)])]
