************ code to use in LISSY, Project: LIS (Not LISPRE); statistical package: STATA


local datasets  at94 at00 at04 at07 at10 at13 at16 au85 au89 au95 au01 au03 au08 au10 au14 be92 be95 be97 be00 ca81 ca87 ca91 ca94 ca97 ca98 ca00 ca04 ca07 ca10 ca13  ch82 ch92  ch07 ch10 ch13 cz92 cz96 cz02 cz04 cz07 cz10 cz13  de73 de78 de83 de84 de89 de94 de00 de04 de07 de10 de13 de15 dk87 dk92 dk95 dk00 dk04 dk07 dk10 dk13  es90 es95 es00 es04 es07 es10 es13 es16 fi87 fi91 fi95 fi00 fi04 fi07 fi10 fi13 fi16 fr78 fr84 fr89 fr94 fr00 fr05 fr10 gr00 gr04 gr07 gr10 gr13 hu91 hu94 hu99 hu05 hu07 hu09 hu12 hu15 ie94 ie95 ie96 ie00 ie04 ie07 ie10  it87 it89 it91 it93 it95 it98 it00 it04 it08 it10 it14 lu85 lu91 lu94 lu97 lu00 lu04 lu07 lu10 lu13 nl83 nl87 nl90 nl93 nl99 nl04 nl07 nl10 nl13 no79 no86 no91 no95 no00 no04 no07 no10 no13 pl92 pl95 pl07  pl13 pl16 se75 se81 se87 se92 se95 se00 se05 si97 si99 si04 si07 si10 si12 sk92 sk04 sk07 sk10 sk13   uk74 uk79 uk86 uk91 uk94 uk95 uk99 uk04 uk07 uk10 uk13 uk16 us74 us79 us86 us91 us94 us97 us00 us04 us07 us10 us13 us16       
   
foreach x of local datasets{   
   
qui{   
   
use pitotal grossnet hid dname pwgt year partner sex age relation pilabour pi12  pi13 status1  emp_ilo  using  $`x'p, clear    
    
    
    
merge m:1 dname hid using   $`x'h, keep(match master) keepusing(hitotal hxitsc hxitax nhhmem hhtype hpartner  region_c hwgt hi12 hi14 hi13 hilabour hicapital hi332)    



**** rename and recode 

rename emp_ilo emp
recode hpartner 0=200
recode hpartner 1=100

recode partner 0=200
recode partner 1=110
rename pilabour pil
rename hilabour hil
recode hpartner 120=110   

**** generate household income variables for comparison  to summing personal incomes
gen hils=hi12+hi14
gen hic= hicapital +hi332
gen pils=pi12

*** code to identify households with one or more self-employed individuals
gen selfie=1 if status>199 & status<400  
  
sort dname hid  
  
by dname hid: egen selfies=total(selfie)  

*** recode negative incomes (primarily among self-employed) to 0
recode pil min/0=0     
recode hil min/0=0     

*** generate indicator for datasets where fringe benefits are only recorded at the household level
gen fringed=.
recode fringed .=1 if dname=="be95"                                
recode fringed .=1 if dname=="cz92"  
recode fringed .=1 if dname=="cz96"  
recode fringed .=1 if dname=="dk87"  
recode fringed .=1 if dname=="dk92"  
recode fringed .=1 if dname=="fr84"  
recode fringed .=1 if dname=="fr10"  
recode fringed .=1 if dname=="it87"  
recode fringed .=1 if dname=="it89"  
recode fringed .=1 if dname=="it91"  
recode fringed .=1 if dname=="it93"  
recode fringed .=1 if dname=="lu85"  
recode fringed .=1 if dname=="lu91"  
recode fringed .=1 if dname=="lu94"  
recode fringed .=1 if dname=="lu97"  
recode fringed .=1 if dname=="no79"  
recode fringed .=1 if dname=="no86"  
recode fringed .=1 if dname=="pl92"  
recode fringed .=1 if dname=="pl07"  
recode fringed .=1 if dname=="pl13"  
recode fringed .=1 if dname=="si99"  
recode fringed .=1 if dname=="si04"  
recode fringed .=1 if dname=="es80"  
recode fringed .=1 if dname=="es85"  
recode fringed .=1 if dname=="es90"  
recode fringed .=1 if dname=="uk79"  
recode fringed .=1 if dname=="uk86"  
recode fringed .=1 if dname=="uk91"  
recode fringed .=1 if dname=="uk95"  
recode fringed .=1 if dname=="uk99"  
recode fringed .=1 if dname=="uk04"  

*** redistribute fringe benefits across individuals based on share of household income
replace pil=pil+(hi13*(pil/hil)) if fringed==1  & hil!=0

*** generate indicator for datasets where self-employed income is only recorded at the household level

gen selfdata=.  
recode selfdata .=1 if dname=="au81"  
recode selfdata .=1 if dname=="au85"  
recode selfdata .=1 if dname=="au89"  
recode selfdata .=1 if dname=="at94"  
recode selfdata .=1 if dname=="at97"  
recode selfdata .=1 if dname=="be95"  
recode selfdata .=1 if dname=="be97"  
recode selfdata .=1 if dname=="ca71"  
recode selfdata .=1 if dname=="ca75"  
recode selfdata .=1 if dname=="ca81"  
recode selfdata .=1 if dname=="ca87"  
recode selfdata .=1 if dname=="ca91"  
recode selfdata .=1 if dname=="ca94"  
recode selfdata .=1 if dname=="ca97"  
recode selfdata .=1 if dname=="cz92"  
recode selfdata .=1 if dname=="cz96"  
recode selfdata .=1 if dname=="dk87"  
recode selfdata .=1 if dname=="dk92"  
recode selfdata .=1 if dname=="ee00"  
recode selfdata .=1 if dname=="fi87"  
recode selfdata .=1 if dname=="fi91"  
recode selfdata .=1 if dname=="fi95"  
recode selfdata .=1 if dname=="fr84"  
recode selfdata .=1 if dname=="fr89"  
recode selfdata .=1 if dname=="fr94"  
recode selfdata .=1 if dname=="de73"  
recode selfdata .=1 if dname=="de78"  
recode selfdata .=1 if dname=="de81"  
recode selfdata .=1 if dname=="de83"  
recode selfdata .=1 if dname=="gr95"  
recode selfdata .=1 if dname=="hu91"  
recode selfdata .=1 if dname=="hu94"  
recode selfdata .=1 if dname=="ie87"  
recode selfdata .=1 if dname=="ie94"  
recode selfdata .=1 if dname=="ie95"  
recode selfdata .=1 if dname=="ie96"  
recode selfdata .=1 if dname=="it86"  
recode selfdata .=1 if dname=="it87"  
recode selfdata .=1 if dname=="it89"  
recode selfdata .=1 if dname=="it91"  
recode selfdata .=1 if dname=="it93"  
recode selfdata .=1 if dname=="lu85"  
recode selfdata .=1 if dname=="lu91"  
recode selfdata .=1 if dname=="lu94"  
recode selfdata .=1 if dname=="lu97"  
recode selfdata .=1 if dname=="mx84"  
recode selfdata .=1 if dname=="mx89"  
recode selfdata .=1 if dname=="mx92"  
recode selfdata .=1 if dname=="mx94"  
recode selfdata .=1 if dname=="mx96"  
recode selfdata .=1 if dname=="nl83"  
recode selfdata .=1 if dname=="nl87"  
recode selfdata .=1 if dname=="nl90"  
recode selfdata .=1 if dname=="nl93"  
recode selfdata .=1 if dname=="no79"  
recode selfdata .=1 if dname=="no86"  
recode selfdata .=1 if dname=="no91"  
recode selfdata .=1 if dname=="no95"  
recode selfdata .=1 if dname=="pl86"  
recode selfdata .=1 if dname=="pl92"  
recode selfdata .=1 if dname=="pl95"  
recode selfdata .=1 if dname=="pl99"  
recode selfdata .=1 if dname=="pl04"  
recode selfdata .=1 if dname=="sk92"  
recode selfdata .=1 if dname=="sk96"  
recode selfdata .=1 if dname=="si97"  
recode selfdata .=1 if dname=="es80"  
recode selfdata .=1 if dname=="es85"  
recode selfdata .=1 if dname=="es90"  
recode selfdata .=1 if dname=="es95"  
recode selfdata .=1 if dname=="se75"  
recode selfdata .=1 if dname=="se81"  
recode selfdata .=1 if dname=="se87"  
recode selfdata .=1 if dname=="se92"  
recode selfdata .=1 if dname=="se95"  
recode selfdata .=1 if dname=="ch82"  
recode selfdata .=1 if dname=="ch92"  
recode selfdata .=1 if dname=="ch00"  
recode selfdata .=1 if dname=="ch02"  
recode selfdata .=1 if dname=="ch04"  
recode selfdata .=1 if dname=="uk69"  
recode selfdata .=1 if dname=="uk74"  
recode selfdata .=1 if dname=="uk79"  
recode selfdata .=1 if dname=="uk86"  
recode selfdata .=1 if dname=="uk91"  
recode selfdata .=1 if dname=="uk94"  
recode selfdata .=1 if dname=="uk95"  
recode selfdata .=1 if dname=="us74"  

*** redistribute self-employed household income across self-employed individuals in household

replace pil=pil+(hils/selfies) if selfie==1 & selfdata==1  



*** generate measure of household income based on summing individual incomes
sort dname hid
by dname hid: egen hhpils=total(pils) if selfdata!=1

*** code to redistribute discrepancy between household income and sum of personal incomes 
**** in households where there are self-employed individuals with zero earnings
gen hilsrest=hils-hhpils if selfdata!=1
gen zeroselfie=1 if status>199 & status<400 & selfdata!=1 & pils==0 
sort dname hid
by dname hid: egen zeroselfies=total(zeroselfie) if selfdata!=1

replace pil=pil+(hilsrest/zeroselfies) if zeroselfie==1 & selfdata!=1 & dname!="fr78"

****** Keep only head of household and partner
drop if relation>2999   

*** code to drop self-employed individuals (and their hh) if after adjustments they still have zero personal income
gen dropself=1 if status>199 & status<400 & pil==0 
sort dname hid
by dname hid: egen dropselfs=total(dropself) 

drop if dropselfs>0 & dropselfs!=. & dname=="ch92"
drop if dropselfs>0 & dropselfs!=. & dname=="fr78"
drop if dropselfs>0 & dropselfs!=. & dname=="fr84"
drop if dropselfs>0 & dropselfs!=. & dname=="fr89"
drop if dropselfs>0 & dropselfs!=. & dname=="fr94"
drop if dropselfs>0 & dropselfs!=. & dname=="fr00"
drop if dropselfs>0 & dropselfs!=. & dname=="fr05"
drop if dropselfs>0 & dropselfs!=. & dname=="fr10"

drop if dropselfs>0 & dropselfs!=. & dname=="hu09"
drop if dropselfs>0 & dropselfs!=. & dname=="nl83"
drop if dropselfs>0 & dropselfs!=. & dname=="nl87"
drop if dropselfs>0 & dropselfs!=. & dname=="nl90"
drop if dropselfs>0 & dropselfs!=. & dname=="nl93"
drop if dropselfs>0 & dropselfs!=. & dname=="nl99"
drop if dropselfs>0 & dropselfs!=. & dname=="nl04"
drop if dropselfs>0 & dropselfs!=. & dname=="nl07"
drop if dropselfs>0 & dropselfs!=. & dname=="nl10"
drop if dropselfs>0 & dropselfs!=. & dname=="nl13"
drop if dropselfs>0 & dropselfs!=. & dname=="pl92"
drop if dropselfs>0 & dropselfs!=. & dname=="pl95"
drop if dropselfs>0 & dropselfs!=. & dname=="pl07"
drop if dropselfs>0 & dropselfs!=. & dname=="pl13"

drop if dropselfs>0 & dropselfs!=. & dname=="sk92"
drop if dropselfs>0 & dropselfs!=. & dname=="sk04"
drop if dropselfs>0 & dropselfs!=. & dname=="sk07"
drop if dropselfs>0 & dropselfs!=. & dname=="sk10"
drop if dropselfs>0 & dropselfs!=. & dname=="sk13"

drop if dropselfs>0 & dropselfs!=. & dname=="uk74" 
drop if dropselfs>0 & dropselfs!=. & dname=="uk79" 
drop if dropselfs>0 & dropselfs!=. & dname=="uk86" 
drop if dropselfs>0 & dropselfs!=. & dname=="uk91" 
drop if dropselfs>0 & dropselfs!=. & dname=="uk94" 
drop if dropselfs>0 & dropselfs!=. & dname=="uk95" 
drop if dropselfs>0 & dropselfs!=. & dname=="uk99" 
drop if dropselfs>0 & dropselfs!=. & dname=="uk04" 
drop if dropselfs>0 & dropselfs!=. & dname=="uk07" 
drop if dropselfs>0 & dropselfs!=. & dname=="uk10" 
drop if dropselfs>0 & dropselfs!=. & dname=="uk13" 
drop if dropselfs>0 & dropselfs!=. & dname=="si97" 
drop if dropselfs>0 & dropselfs!=. & dname=="si99" 
drop if dropselfs>0 & dropselfs!=. & dname=="si04"
drop if dropselfs>0 & dropselfs!=. & dname=="si07" 
drop if dropselfs>0 & dropselfs!=. & dname=="si10" 
 drop if dropselfs>0 & dropselfs!=. & dname=="si12" 
 drop if dropselfs>0 & dropselfs!=. 


 
 
sort dname hid  
by dname hid: egen hhpil2=total(pil)  
gen hhpil=hhpil2/(sqrt(nhhmem))
*** Solt income definition
gen mi=(hil+hic)/(sqrt(nhhmem))
*** Our income definition
gen mi2=(hhpil2+hic)/(sqrt(nhhmem))
  
}
display dname "correlation of original LIS household income with our measure of household income (before netting out)" 
pwcorr hil hhpil2 

qui{

**** in selected countries, drop households of employed individuals with zero labor income
  
gen zerolab=1 if emp==1 & pil==0   
recode zerolab .=0 if emp==1 & pil>0 & pil!=.   

sort dname hid
by dname hid: egen drops=total(zerolab) 

drop if drops>0 & drops!=. & dname=="ca81"
drop if drops>0 & drops!=. & dname=="hu94"
drop if drops>0 & drops!=. & dname=="uk95"
drop if drops>0 & drops!=. & dname=="ch92"
drop if drops>0 & drops!=. & dname=="fr78"
drop if drops>0 & drops!=. & dname=="fr84"
drop if drops>0 & drops!=. & dname=="hu09"
drop if drops>0 & drops!=. & dname=="nl83"
drop if drops>0 & drops!=. & dname=="pl92"
drop if drops>0 & drops!=. & dname=="uk86"

******  comparison of inequality based on household income and sum of personal incomes after adjustments
ineqdeco hhpil2  [aweight=hwgt]
gen ourgini=r(gini)
ineqdeco hil  [aweight=hwgt]
gen lisgini=r(gini)

}  
display dname  "gini based on LIS household income"  
sum lisgini

display dname  "gini based on our household income"  
sum ourgini


qui{  
    
*** drop overseas regions in France   
drop if dname=="fr10" & region_c>8 & region_c!=.      
     
drop _merge      
      
   
**** generate variables that indicate each persons' personal info for all members of household   
   
***   
   
gen hage=age if relation==1000   
sort dname hid   
   
by dname hid: egen hagem=max(hage)   
  
  
gen hsex1=sex if relation==1000   
sort dname hid   
   
by dname hid: egen hsex=max(hsex1)   
  
*** drop household where head of household is out of age range   
drop if hagem>54 | hagem<30    
drop if age==.     
   
gen page=age if relation>1999 & relation<3000   
sort dname hid   
   
by dname hid: egen pagem=max(page)   
*** drop household where partner is out of age range   

drop if pagem>54   & pagem!=.   
drop if pagem<30   & pagem!=.   
   
*** net out incomes in countries that have inconsistent series   
recode pil min/0=0     
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="at04"

replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="at07"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="at10"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="at13"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="at16"

replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="be92"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="be97"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="es07"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="es10"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="es13"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="gr07"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="gr10"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="gr13"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="ie04"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="ie07"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="ie10"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="lu04"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="lu07"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="lu10"
replace pil= ((hitotal-hxitsc)/hitotal)*pil if dname=="lu13"


***** cap income at the top, 10 times median personal income
sum pil [aweight=pwgt] if relation<3000, det                
              
gen medianpil=r(p50)              
gen cap=10*medianpil              
          
replace pil=cap  if pil>cap & pil!=. 


   
*** rename for reasons no longer needed
gen dfpil= pil  
   
gen mil1=dfpil if relation==1000   
   
   
    
   
**** Exclude households that somehow still have more than two persons despite only keeping partners and head of household
sort dname hid     
     
by dname hid: gen test=_N   
tab test   
drop if test>2 & test!=.   
  
drop test    
   
**** drop same-sex couples   
sort dname hid     
     
by dname hid: gen othersex=sex if relation==1000     
by dname hid: egen othersex2=max(othersex)     
     
gen samesex=1 if othersex2==sex & relation!=1000     
sort dname hid     
by dname hid: egen samesex2=max(samesex)     
     
drop if samesex2==1     
drop othersex othersex2 samesex samesex2     
   
****  

  
*** generate indicators of male and female income on hosuehold level  
gen ml1=dfpil if sex==1   
   
 
sort dname hid   
   
by dname hid: egen ml=max(ml1)   
   
   
gen fl1=dfpil if sex==2   
   
   
sort dname hid   
   
by dname hid: egen fl=max(fl1)   

  
*** only keep one observation per household   
by dname hid: keep if _n==1   

}
**** inequality measures 
display dname "cv"
tabstat dfpil [aweight=hwgt], statistics(cv)
display dname "gini"
sgini dfpil [aweight=hwgt]
qui{


*** summarize her share of couple income  
gen hershare=fl/(ml+fl) if ml!=. & fl!=. & hpartner<200  
sum hershare [aweight=hwgt]  
gen femincshare=r(mean)   

*** divide male and female earnings distribution into 20 groups   
xtile mtwinties= ml if ml>0 & hpartner<200 [aweight=hwgt], nquantile(20)    
xtile ftwinties= fl if fl>0 & hpartner<200 [aweight=hwgt], nquantile(20)    
        
*** assign separate category to those with zero income
recode mtwinties .=30 if ml==0 & hpartner<200  
recode ftwinties .=30 if fl==0 & hpartner<200  
   
sort mtwinties    
by mtwinties: egen medml=median(ml)     

*** extra code to inspect relationship between partners earnings
display "median labor income by twintiles men"   
tab mtwinties, sum(medml)   
    
sort ftwinties    
by ftwinties: egen medfl=median(fl)     
display "median labor income by twintiles women"   
tab ftwinties, sum(medfl)   
     
   
tab ftwinties, sum(medfl)   


xtile mtenties= ml if ml>0 & hpartner<200  [aweight=hwgt], nquantile(10)    
xtile ftenties= fl if fl>0 & hpartner<200   [aweight=hwgt], nquantile(10)   

recode mtenties .=30 if ml==0 & hpartner<200  
recode ftenties .=30 if fl==0 & hpartner<200  

*** generate indicators for zero-earners
gen memp=0 if ml==0
recode memp .=1 if ml>0 & ml!=.

gen femp=0 if fl==0
recode femp .=1 if fl>0 & fl!=. 
 
}

*** descriptive numbers
display dname "share of men employed by women's earnings"
table ftenties, contents(mean memp)


display dname "share of women employed by men's earnings"
table mtenties, contents(mean femp)
   
display dname "correlation between her earnings and his employment"
pwcorr fl memp
   
display dname "correlation between his earnings and her employment"
pwcorr ml femp
    
display dname "correlation between his and her earnings, including zero-earners"
pwcorr fl ml  

display dname "correlation between his and her earnings among dual earners"
pwcorr fl ml  if mtwinties!=30 & ftwinties!=30



qui{
   
**** Code to make sure we have 20 twintiles with info and add twintiles if not (due to % cases with a specific value covering more than one twintiles)
**** this is a long piece of code, first for men than for women
*** it consists of creating 21 cases with info on the different twintiles of earnings + zero earners. This also includes copying info from different rows if there are twintiles with the same value
gen nonmiss=1 if ftwinties!=. & mtwinties!=.   
  
   
label variable ftwinties "f"   
label variable mtwinties "m"   
  
  
  
sort nonmiss mtwinties  
by nonmiss mtwinties: gen test2=_n  
  
sort nonmiss test2 mtwinties   
  
  
gen extra=1 in 1/21  
  
expand 2 if extra==1 & test2!=1,generate(dupl)  
  
recode extra 1=. if dupl==0 & test2!=1  
  
replace mtwinties=1 if dupl==1  
  
sort extra mtwinties test2   
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
sort extra mtwinties test2  
by extra: replace mtwinties=mtwinties+1 if extra==1 & mtwinties==mtwinties[_n-1] & dupl==1  
  
tab ftwinties if dupl==1  
tab mtwinties if dupl==1  
  
tab ftwinties  
tab mtwinties  
  

  
sort extra mtwinties test2  
by extra: replace medml=medml[_n-1] if dupl==1 & mtwinties<21  
replace medml=0 if dupl==1 & mtwinties>20 & mtwinties<41  


rename dupl dupl_m  
*** women   
drop test2 extra 
sort nonmiss ftwinties  
by nonmiss ftwinties: gen test2=_n  
  
sort nonmiss test2 ftwinties   
  
gen extra=1 in 1/21  
  
  
  
expand 2 if extra==1 & test2!=1,generate(dupl)  
  
recode extra 1=. if dupl==0 & test2!=1  
  
replace ftwinties=1 if dupl==1  
  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
sort extra ftwinties test2   
by extra: replace ftwinties=ftwinties+1 if extra==1 & ftwinties==ftwinties[_n-1] & dupl==1  
  
  
sort extra ftwinties test2  
by extra: replace medfl=medfl[_n-1] if dupl==1 & ftwinties<21  
replace medfl=0 if dupl==1 & ftwinties>20 & ftwinties<41  

*********** generate variables that indicate frequency of couples in each combined group of his and her earnings including weights
gen nonmiss2=1 if ftwinties!=. & mtwinties!=.   
   
sort nonmiss2  
by nonmiss2: egen totwgt=total(hwgt) if nonmiss2==1   
   
sort nonmiss2 ftwinties mtwinties    
by nonmiss2 ftwinties mtwinties: egen grpwgt=total(hwgt)  if nonmiss2==1   
   
gen grpsh=grpwgt/totwgt if nonmiss2==1   
   
tab ftwinties if nonmiss2==1   
   
gen samplesize=r(N)   
   
gen grpfreq=grpsh*samplesize   
   
sort nonmiss2 ftwinties mtwinties   
by nonmiss2 ftwinties mtwinties: gen test=grpfreq if _n==1   
   
egen test1=total(test)   


****** code to split cases across newly created twintiles. 

sort ftwinties

by ftwinties: gen tott=_n

sort tott 

gen ddd=1 in 1/21

sort tott ftwinties
by tott: gen dupl1=1 if dupl==0  & dupl[_n+1]==1 & ddd==1
by tott: gen dupl2=1 if dupl==0  & dupl[_n+2]==1 & dupl1==1 & ddd==1
by tott: gen dupl3=1 if dupl==0  & dupl[_n+3]==1 & dupl2==1 & ddd==1
by tott: gen dupl4=1 if dupl==0  & dupl[_n+4]==1 & dupl3==1 & ddd==1



egen dupsum=rowtotal(dupl1 dupl2 dupl3 dupl4)
sort ftwinties  
by ftwinties: egen mdupsum=max(dupsum)

*** 2

expand 2 if mdupsum==1,generate(ff1)  

sort hid ff1
by hid ff1: gen seq=_n if ff1==1

replace ftwinties=ftwinties+1 if seq==1


replace grpfreq=grpfreq/2 if mdupsum==1


** 3
expand 3 if mdupsum==2,generate(ff2)  

sort hid ff2
by hid ff2: gen seq2=_n if ff2==1

replace ftwinties=ftwinties+1 if seq2==1
replace ftwinties=ftwinties+2 if seq2==2

replace grpfreq=grpfreq/3 if mdupsum==2

** 4

expand 4 if mdupsum==3,generate(ff3)  

sort hid ff3
by hid ff3: gen seq3=_n if ff3==1

replace ftwinties=ftwinties+1 if seq3==1
replace ftwinties=ftwinties+2 if seq3==2
replace ftwinties=ftwinties+3 if seq3==3

replace grpfreq=grpfreq/4 if mdupsum==3

drop tott ddd dupl1 dupl2 dupl3 dupl4 dupsum mdupsum ff1 ff2 ff3  seq seq2 seq3
********************

****** 

sort mtwinties

by mtwinties: gen tott=_n

sort tott 

gen ddd=1 in 1/21

sort tott mtwinties
by tott: gen dupl1=1 if dupl_m==0  & dupl_m[_n+1]==1 & ddd==1
by tott: gen dupl2=1 if dupl_m==0  & dupl_m[_n+2]==1 & dupl1==1 & ddd==1
by tott: gen dupl3=1 if dupl_m==0  & dupl_m[_n+3]==1 & dupl2==1 & ddd==1
by tott: gen dupl4=1 if dupl_m==0  & dupl_m[_n+4]==1 & dupl3==1 & ddd==1


egen dupsum=rowtotal(dupl1 dupl2 dupl3 dupl4)
sort mtwinties  
by mtwinties: egen mdupsum=max(dupsum)

*** 2

expand 2 if mdupsum==1, generate(ff1)  

sort hid ff1
by hid ff1: gen seq=_n if ff1==1

replace mtwinties=mtwinties+1 if seq==1


replace grpfreq=grpfreq/2 if mdupsum==1


** 3
expand 3 if mdupsum==2,generate(ff2)  

sort hid ff2
by hid ff2: gen seq2=_n if ff2==1

replace mtwinties=mtwinties+1 if seq2==1
replace mtwinties=mtwinties+2 if seq2==2

replace grpfreq=grpfreq/3 if mdupsum==2

** 4

expand 4 if mdupsum==3,generate(ff3)  

sort hid ff3
by hid ff3: gen seq3=_n if ff3==1

replace mtwinties=mtwinties+1 if seq3==1
replace mtwinties=mtwinties+2 if seq3==2
replace mtwinties=mtwinties+3 if seq3==3

replace grpfreq=grpfreq/4 if mdupsum==3

drop tott ddd dupl1 dupl2 dupl3 dupl4 dupsum mdupsum ff1 ff2 ff3  seq seq2 seq3
********************


}


  
display "new dataset" 
display "sample size" 
display samplesize    

**** twintile values
display dname   
table ftwinties, contents(mean medfl)   
display dname   
table mtwinties, contents(mean medml)   

**** distribution of couples across twintiles of him and her

display dname   
tabdisp mtwinties ftwinties if ftwinties!=. & mtwinties!=., cellvar(grpfreq)  csepwidth(1)  stubwidth(4) scsepwidth(1) missing   
display dname "  women's earnings share"  
display femincshare  
 
 
   
clear all   
}   
